<?php //$Id: block_tag_html.php,v 1.5 2009/02/23 19:16:46 stronk7 Exp $

///////////////////////////////////////////////////////////////////////////
//                                                                       //
// NOTICE OF COPYRIGHT                                                   //
//                                                                       //
// Moodle - Modular Object-Oriented Dynamic Learning Environment         //
//          http://moodle.com                                            //
//                                                                       //
// Copyright (C) 2001-3001 Martin Dougiamas        http://dougiamas.com  //
//           (C) 2001-3001 Eloy Lafuente (stronk7) http://contiento.com  //
//           (C) 2001-3001 Antonio Vicent          http://ludens.es      //
//                                                                       //
// This program is free software; you can redistribute it and/or modify  //
// it under the terms of the GNU General Public License as published by  //
// the Free Software Foundation; either version 2 of the License, or     //
// (at your option) any later version.                                   //
//                                                                       //
// This program is distributed in the hope that it will be useful,       //
// but WITHOUT ANY WARRANTY; without even the implied warranty of        //
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         //
// GNU General Public License for more details:                          //
//                                                                       //
//          http://www.gnu.org/copyleft/gpl.html                         //
//                                                                       //
///////////////////////////////////////////////////////////////////////////

/// This block just displays the configured (globally) html, with the
/// [[tag]] keys replaced with the current tag being visited

require_once($CFG->dirroot.'/tag/lib.php');

class block_tag_html extends block_base {

    function init() {
        $this->title = get_string('tag_html', 'block_tag_html');
        $this->version = 2009022300;
    }

    function applicable_formats() {
        return array('tag' => true);
    }

    function specialization() {

        global $CFG;

        $this->title = !empty($CFG->block_tag_html_title) ? $CFG->block_tag_html_title : '';;
    }

    function has_config() {
        return true;
    }

    function get_content() {

        global $CFG;

        if ($this->content !== NULL) {
            return $this->content;
        }

    /// Fetch current tag and get its encoded value
        $tagid = optional_param('id', 0, PARAM_INT); // Backwards compatibility
        $tag = optional_param('tag', '', PARAM_TAG);

        if ($tag) {
            $tag_object = tag_get('name', $tag);
        } else if ($tagid) {
            $tag_object = tag_get('id', $tagid);
        }

        if (empty($tag_object)) {
            print_error('tagnotfound');
        }

        $query_tag = tag_display_name($tag_object);
        $query_tag = urlencode($query_tag);

        $filteropt = new stdClass;
        $filteropt->noclean = true;

        $this->content = new stdClass;
        if (!empty($query_tag) && !empty($CFG->block_tag_html_content)) {
            $textlib = textlib_get_instance();
            $text = str_replace('[[tag]]', $query_tag, $CFG->block_tag_html_content);
            $text = str_replace('[[-tag]]', $textlib->strtolower($query_tag), $text);
            $text = str_replace('[[+tag]]', $textlib->strtoupper($query_tag), $text);
            $this->content->text = format_text($text, FORMAT_HTML, $filteropt);
        }
        $this->content->footer = '';

        unset($filteropt);

        return $this->content;
    }

}

?>
